# 🚀 Civitos SDK

[![PyPI](https://img.shields.io/pypi/v/civitos-sdk.svg)](https://pypi.org/project/civitos-sdk/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/civitos-sdk.svg)](https://pypistats.org/packages/civitos-sdk)
[![PyPI - License](https://img.shields.io/pypi/l/civitos-sdk.svg)](https://opensource.org/licenses/MIT)

Civitos SDK is a Python client for interacting with the **Civitos API**.

## 📦 Installation
```sh
pip install civitos-sdk
```

## 🚀 Quick Start
```python
from civitos_sdk import ApiClient, DefaultApi

client = ApiClient()
api = DefaultApi(client)

response = api.get_some_data()
print(response)
```

## 📚 Documentation
- **API Docs:** [Swagger](https://api-test.civitos.com/api/v1/swagger)
- **SDK Guide:** [Docs](https://api-test.civitos.com/docs/)

