# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from civitos_sdk.models.locality import Locality
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    Address
    """ # noqa: E501
    id: Optional[StrictInt] = None
    address_line_1: Optional[Annotated[str, Field(strict=True, max_length=255)]] = None
    address_line_2: Optional[Annotated[str, Field(strict=True, max_length=255)]] = None
    locality: Optional[Locality] = None
    locality_id: Optional[StrictInt] = None
    raw: Optional[StrictStr] = None
    formatted: Optional[StrictStr] = None
    latitude: Optional[Union[StrictFloat, StrictInt]] = None
    longitude: Optional[Union[StrictFloat, StrictInt]] = None
    country_name: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    country_code: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    state_name: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    state_code: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    __properties: ClassVar[List[str]] = ["id", "address_line_1", "address_line_2", "locality", "locality_id", "raw", "formatted", "latitude", "longitude", "country_name", "country_code", "state_name", "state_code"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "country_name",
            "country_code",
            "state_name",
            "state_code",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of locality
        if self.locality:
            _dict['locality'] = self.locality.to_dict()
        # set to None if address_line_1 (nullable) is None
        # and model_fields_set contains the field
        if self.address_line_1 is None and "address_line_1" in self.model_fields_set:
            _dict['address_line_1'] = None

        # set to None if address_line_2 (nullable) is None
        # and model_fields_set contains the field
        if self.address_line_2 is None and "address_line_2" in self.model_fields_set:
            _dict['address_line_2'] = None

        # set to None if raw (nullable) is None
        # and model_fields_set contains the field
        if self.raw is None and "raw" in self.model_fields_set:
            _dict['raw'] = None

        # set to None if formatted (nullable) is None
        # and model_fields_set contains the field
        if self.formatted is None and "formatted" in self.model_fields_set:
            _dict['formatted'] = None

        # set to None if latitude (nullable) is None
        # and model_fields_set contains the field
        if self.latitude is None and "latitude" in self.model_fields_set:
            _dict['latitude'] = None

        # set to None if longitude (nullable) is None
        # and model_fields_set contains the field
        if self.longitude is None and "longitude" in self.model_fields_set:
            _dict['longitude'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "address_line_1": obj.get("address_line_1"),
            "address_line_2": obj.get("address_line_2"),
            "locality": Locality.from_dict(obj["locality"]) if obj.get("locality") is not None else None,
            "locality_id": obj.get("locality_id"),
            "raw": obj.get("raw"),
            "formatted": obj.get("formatted"),
            "latitude": obj.get("latitude"),
            "longitude": obj.get("longitude"),
            "country_name": obj.get("country_name"),
            "country_code": obj.get("country_code"),
            "state_name": obj.get("state_name"),
            "state_code": obj.get("state_code")
        })
        return _obj


