# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.address import Address
from typing import Optional, Set
from typing_extensions import Self

class AddressBookContactSerializer(BaseModel):
    """
    AddressBookContactSerializer
    """ # noqa: E501
    sqid: Optional[StrictStr] = None
    office: StrictStr
    first_name: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="The first name of the contact.")
    middle_name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The middle name of the contact, if any.")
    last_name: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="The last name of the contact.")
    email: Annotated[str, Field(strict=True, max_length=254)] = Field(description="The email address of the contact, if available.")
    preferred_name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The name the contact prefers to be called.")
    date_of_birth: Optional[date] = Field(default=None, description="The date of birth of the contact, if applicable.")
    notes: Optional[StrictStr] = Field(default=None, description="Additional notes or information about the contact.")
    job_title: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The contact's job title.")
    tags: Optional[List[Annotated[str, Field(min_length=1, strict=True)]]] = None
    address: Optional[Address] = None
    __properties: ClassVar[List[str]] = ["sqid", "office", "first_name", "middle_name", "last_name", "email", "preferred_name", "date_of_birth", "notes", "job_title", "tags", "address"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddressBookContactSerializer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sqid",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # set to None if date_of_birth (nullable) is None
        # and model_fields_set contains the field
        if self.date_of_birth is None and "date_of_birth" in self.model_fields_set:
            _dict['date_of_birth'] = None

        # set to None if tags (nullable) is None
        # and model_fields_set contains the field
        if self.tags is None and "tags" in self.model_fields_set:
            _dict['tags'] = None

        # set to None if address (nullable) is None
        # and model_fields_set contains the field
        if self.address is None and "address" in self.model_fields_set:
            _dict['address'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddressBookContactSerializer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sqid": obj.get("sqid"),
            "office": obj.get("office"),
            "first_name": obj.get("first_name"),
            "middle_name": obj.get("middle_name"),
            "last_name": obj.get("last_name"),
            "email": obj.get("email"),
            "preferred_name": obj.get("preferred_name"),
            "date_of_birth": obj.get("date_of_birth"),
            "notes": obj.get("notes"),
            "job_title": obj.get("job_title"),
            "tags": obj.get("tags"),
            "address": Address.from_dict(obj["address"]) if obj.get("address") is not None else None
        })
        return _obj


