# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class AddressBookOrganizationSerializer(BaseModel):
    """
    AddressBookOrganizationSerializer
    """ # noqa: E501
    sqid: Optional[StrictStr] = None
    office: StrictStr
    name: Annotated[str, Field(min_length=1, strict=True, max_length=255)]
    contacts: Optional[List[StrictStr]] = None
    notes: Optional[StrictStr] = None
    website: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="The organization's website.")
    email: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="Primary email address for the organization.")
    phone_number: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="Main phone number for the organization.")
    fax_number: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="Fax number for the organization.")
    address: Optional[StrictStr] = Field(default=None, description="Headquarters or main address of the organization.")
    industry: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The industry the organization belongs to.")
    tax_id: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="Tax Identification Number or equivalent.")
    registration_number: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="Official registration number of the organization.")
    established_date: Optional[date] = Field(default=None, description="Date when the organization was established.")
    logo: Optional[StrictStr] = Field(default=None, description="Logo of the organization.")
    active: Optional[StrictBool] = Field(default=None, description="Indicates if the organization is currently active.")
    __properties: ClassVar[List[str]] = ["sqid", "office", "name", "contacts", "notes", "website", "email", "phone_number", "fax_number", "address", "industry", "tax_id", "registration_number", "established_date", "logo", "active"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddressBookOrganizationSerializer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sqid",
            "logo",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if established_date (nullable) is None
        # and model_fields_set contains the field
        if self.established_date is None and "established_date" in self.model_fields_set:
            _dict['established_date'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddressBookOrganizationSerializer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sqid": obj.get("sqid"),
            "office": obj.get("office"),
            "name": obj.get("name"),
            "contacts": obj.get("contacts"),
            "notes": obj.get("notes"),
            "website": obj.get("website"),
            "email": obj.get("email"),
            "phone_number": obj.get("phone_number"),
            "fax_number": obj.get("fax_number"),
            "address": obj.get("address"),
            "industry": obj.get("industry"),
            "tax_id": obj.get("tax_id"),
            "registration_number": obj.get("registration_number"),
            "established_date": obj.get("established_date"),
            "logo": obj.get("logo"),
            "active": obj.get("active")
        })
        return _obj


