# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class AddressBookPhoneNumberSerializer(BaseModel):
    """
    AddressBookPhoneNumberSerializer
    """ # noqa: E501
    sqid: Optional[StrictStr] = None
    office: StrictStr
    contact: StrictStr
    number: Annotated[str, Field(min_length=1, strict=True, max_length=128)] = Field(description="The phone number, including the country code and area code.")
    type: Optional[StrictStr] = Field(default=None, description="The type of phone number, such as home, work, or mobile.")
    formatted_number: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["sqid", "office", "contact", "number", "type", "formatted_number"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['home', 'work', 'mobile']):
            raise ValueError("must be one of enum values ('home', 'work', 'mobile')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddressBookPhoneNumberSerializer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sqid",
            "formatted_number",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddressBookPhoneNumberSerializer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sqid": obj.get("sqid"),
            "office": obj.get("office"),
            "contact": obj.get("contact"),
            "number": obj.get("number"),
            "type": obj.get("type"),
            "formatted_number": obj.get("formatted_number")
        })
        return _obj


