# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class County(BaseModel):
    """
    County
    """ # noqa: E501
    id: Optional[StrictInt] = None
    name: Annotated[str, Field(min_length=1, strict=True, max_length=255)]
    full_name: Annotated[str, Field(strict=True, max_length=255)]
    state_fips: Annotated[str, Field(min_length=1, strict=True, max_length=2)]
    county_fips: Annotated[str, Field(min_length=1, strict=True, max_length=3)]
    fips_code: Annotated[str, Field(min_length=1, strict=True, max_length=5)]
    county_namespace_code: Optional[Annotated[str, Field(strict=True, max_length=20)]] = None
    legal_statistical_description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = None
    legal_statistical_description_code: Optional[Annotated[str, Field(strict=True, max_length=10)]] = None
    fips_class_code: Optional[Annotated[str, Field(strict=True, max_length=10)]] = None
    maf_tiger_feature_class: Optional[Annotated[str, Field(strict=True, max_length=10)]] = None
    functional_status: Optional[Annotated[str, Field(strict=True, max_length=1)]] = None
    latitude: Optional[Union[StrictFloat, StrictInt]] = None
    longitude: Optional[Union[StrictFloat, StrictInt]] = None
    land_area: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    water_area: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    total_housing_units: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    occupied_housing_units: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    vacant_housing_units: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    total_population: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    median_home_value: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    median_household_income: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    stats: Optional[Dict[str, Any]] = None
    state: StrictInt
    __properties: ClassVar[List[str]] = ["id", "name", "full_name", "state_fips", "county_fips", "fips_code", "county_namespace_code", "legal_statistical_description", "legal_statistical_description_code", "fips_class_code", "maf_tiger_feature_class", "functional_status", "latitude", "longitude", "land_area", "water_area", "total_housing_units", "occupied_housing_units", "vacant_housing_units", "total_population", "median_home_value", "median_household_income", "stats", "state"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of County from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if latitude (nullable) is None
        # and model_fields_set contains the field
        if self.latitude is None and "latitude" in self.model_fields_set:
            _dict['latitude'] = None

        # set to None if longitude (nullable) is None
        # and model_fields_set contains the field
        if self.longitude is None and "longitude" in self.model_fields_set:
            _dict['longitude'] = None

        # set to None if land_area (nullable) is None
        # and model_fields_set contains the field
        if self.land_area is None and "land_area" in self.model_fields_set:
            _dict['land_area'] = None

        # set to None if water_area (nullable) is None
        # and model_fields_set contains the field
        if self.water_area is None and "water_area" in self.model_fields_set:
            _dict['water_area'] = None

        # set to None if total_housing_units (nullable) is None
        # and model_fields_set contains the field
        if self.total_housing_units is None and "total_housing_units" in self.model_fields_set:
            _dict['total_housing_units'] = None

        # set to None if occupied_housing_units (nullable) is None
        # and model_fields_set contains the field
        if self.occupied_housing_units is None and "occupied_housing_units" in self.model_fields_set:
            _dict['occupied_housing_units'] = None

        # set to None if vacant_housing_units (nullable) is None
        # and model_fields_set contains the field
        if self.vacant_housing_units is None and "vacant_housing_units" in self.model_fields_set:
            _dict['vacant_housing_units'] = None

        # set to None if total_population (nullable) is None
        # and model_fields_set contains the field
        if self.total_population is None and "total_population" in self.model_fields_set:
            _dict['total_population'] = None

        # set to None if median_home_value (nullable) is None
        # and model_fields_set contains the field
        if self.median_home_value is None and "median_home_value" in self.model_fields_set:
            _dict['median_home_value'] = None

        # set to None if median_household_income (nullable) is None
        # and model_fields_set contains the field
        if self.median_household_income is None and "median_household_income" in self.model_fields_set:
            _dict['median_household_income'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of County from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "full_name": obj.get("full_name"),
            "state_fips": obj.get("state_fips"),
            "county_fips": obj.get("county_fips"),
            "fips_code": obj.get("fips_code"),
            "county_namespace_code": obj.get("county_namespace_code"),
            "legal_statistical_description": obj.get("legal_statistical_description"),
            "legal_statistical_description_code": obj.get("legal_statistical_description_code"),
            "fips_class_code": obj.get("fips_class_code"),
            "maf_tiger_feature_class": obj.get("maf_tiger_feature_class"),
            "functional_status": obj.get("functional_status"),
            "latitude": obj.get("latitude"),
            "longitude": obj.get("longitude"),
            "land_area": obj.get("land_area"),
            "water_area": obj.get("water_area"),
            "total_housing_units": obj.get("total_housing_units"),
            "occupied_housing_units": obj.get("occupied_housing_units"),
            "vacant_housing_units": obj.get("vacant_housing_units"),
            "total_population": obj.get("total_population"),
            "median_home_value": obj.get("median_home_value"),
            "median_household_income": obj.get("median_household_income"),
            "stats": obj.get("stats"),
            "state": obj.get("state")
        })
        return _obj


