# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.chip import Chip
from typing import Optional, Set
from typing_extensions import Self

class MenuItem(BaseModel):
    """
    MenuItem
    """ # noqa: E501
    id: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="A unique identifier for the menu item.")
    title: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="The display title of the menu item.")
    type: Annotated[str, Field(min_length=1, strict=True, max_length=50)] = Field(description="The type of the menu item.")
    url: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The URL the menu item links to, if applicable.")
    icon: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The icon associated with the menu item, represented as a string.")
    target: Optional[StrictBool] = Field(default=None, description="Whether the menu item should open in a new tab.")
    breadcrumbs: Optional[StrictBool] = Field(default=None, description="Whether this menu item should appear in breadcrumbs.")
    chip: Optional[Chip] = None
    children: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id", "title", "type", "url", "icon", "target", "breadcrumbs", "chip", "children"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MenuItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "children",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of chip
        if self.chip:
            _dict['chip'] = self.chip.to_dict()
        # set to None if breadcrumbs (nullable) is None
        # and model_fields_set contains the field
        if self.breadcrumbs is None and "breadcrumbs" in self.model_fields_set:
            _dict['breadcrumbs'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MenuItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "type": obj.get("type"),
            "url": obj.get("url"),
            "icon": obj.get("icon"),
            "target": obj.get("target"),
            "breadcrumbs": obj.get("breadcrumbs"),
            "chip": Chip.from_dict(obj["chip"]) if obj.get("chip") is not None else None,
            "children": obj.get("children")
        })
        return _obj


