# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.order_manager_property_type import OrderManagerPropertyType
from typing import Optional, Set
from typing_extensions import Self

class ModelProperty(BaseModel):
    """
    ModelProperty
    """ # noqa: E501
    id: Optional[StrictInt] = None
    property_type: OrderManagerPropertyType
    address: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="Street address of the property.")
    address_line2: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="Street address of the property.")
    city: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="City where the property is located.")
    state: Annotated[str, Field(min_length=1, strict=True, max_length=50)] = Field(description="State where the property is located.")
    postal_code: Annotated[str, Field(min_length=1, strict=True, max_length=20)] = Field(description="Postal code for the property.")
    county: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="County where the property is located.")
    country: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=100)]] = Field(default=None, description="Country where the property is located.")
    parcel_number: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="Unique parcel or tax identification number for the property.")
    legal_description: Optional[StrictStr] = Field(default=None, description="The legal description of the property.")
    created_at: Optional[datetime] = Field(default=None, description="The date and time the property was created.")
    updated_at: Optional[datetime] = Field(default=None, description="The date and time the property was last updated.")
    sqid: Optional[StrictStr] = None
    office: StrictInt
    __properties: ClassVar[List[str]] = ["id", "property_type", "address", "address_line2", "city", "state", "postal_code", "county", "country", "parcel_number", "legal_description", "created_at", "updated_at", "sqid", "office"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ModelProperty from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "created_at",
            "updated_at",
            "sqid",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of property_type
        if self.property_type:
            _dict['property_type'] = self.property_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ModelProperty from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "property_type": OrderManagerPropertyType.from_dict(obj["property_type"]) if obj.get("property_type") is not None else None,
            "address": obj.get("address"),
            "address_line2": obj.get("address_line2"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "postal_code": obj.get("postal_code"),
            "county": obj.get("county"),
            "country": obj.get("country"),
            "parcel_number": obj.get("parcel_number"),
            "legal_description": obj.get("legal_description"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "sqid": obj.get("sqid"),
            "office": obj.get("office")
        })
        return _obj


