# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.loan import Loan
from civitos_sdk.models.model_property import ModelProperty
from civitos_sdk.models.order_manager_order_status import OrderManagerOrderStatus
from civitos_sdk.models.order_manager_place_of_closing import OrderManagerPlaceOfClosing
from civitos_sdk.models.order_manager_transaction_type import OrderManagerTransactionType
from civitos_sdk.models.party import Party
from civitos_sdk.models.policy import Policy
from typing import Optional, Set
from typing_extensions import Self

class Order(BaseModel):
    """
    Order
    """ # noqa: E501
    id: Optional[StrictInt] = None
    order_number: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="Unique identifier for the order.")
    purchase_price: Optional[StrictStr] = None
    status: Optional[OrderManagerOrderStatus] = None
    transaction_type: Optional[OrderManagerTransactionType] = None
    place_of_closing: Optional[OrderManagerPlaceOfClosing] = None
    created_at: Optional[datetime] = Field(default=None, description="The date and time the party was created.")
    updated_at: Optional[datetime] = Field(default=None, description="The date and time the party was last updated.")
    properties: Optional[List[ModelProperty]] = None
    parties: Optional[List[Party]] = None
    policies: Optional[List[Policy]] = None
    loans: Optional[List[Loan]] = None
    __properties: ClassVar[List[str]] = ["id", "order_number", "purchase_price", "status", "transaction_type", "place_of_closing", "created_at", "updated_at", "properties", "parties", "policies", "loans"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Order from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "created_at",
            "updated_at",
            "properties",
            "parties",
            "policies",
            "loans",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transaction_type
        if self.transaction_type:
            _dict['transaction_type'] = self.transaction_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of place_of_closing
        if self.place_of_closing:
            _dict['place_of_closing'] = self.place_of_closing.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in properties (list)
        _items = []
        if self.properties:
            for _item_properties in self.properties:
                if _item_properties:
                    _items.append(_item_properties.to_dict())
            _dict['properties'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in parties (list)
        _items = []
        if self.parties:
            for _item_parties in self.parties:
                if _item_parties:
                    _items.append(_item_parties.to_dict())
            _dict['parties'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in policies (list)
        _items = []
        if self.policies:
            for _item_policies in self.policies:
                if _item_policies:
                    _items.append(_item_policies.to_dict())
            _dict['policies'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in loans (list)
        _items = []
        if self.loans:
            for _item_loans in self.loans:
                if _item_loans:
                    _items.append(_item_loans.to_dict())
            _dict['loans'] = _items
        # set to None if purchase_price (nullable) is None
        # and model_fields_set contains the field
        if self.purchase_price is None and "purchase_price" in self.model_fields_set:
            _dict['purchase_price'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Order from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "order_number": obj.get("order_number"),
            "purchase_price": obj.get("purchase_price"),
            "status": OrderManagerOrderStatus.from_dict(obj["status"]) if obj.get("status") is not None else None,
            "transaction_type": OrderManagerTransactionType.from_dict(obj["transaction_type"]) if obj.get("transaction_type") is not None else None,
            "place_of_closing": OrderManagerPlaceOfClosing.from_dict(obj["place_of_closing"]) if obj.get("place_of_closing") is not None else None,
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "properties": [ModelProperty.from_dict(_item) for _item in obj["properties"]] if obj.get("properties") is not None else None,
            "parties": [Party.from_dict(_item) for _item in obj["parties"]] if obj.get("parties") is not None else None,
            "policies": [Policy.from_dict(_item) for _item in obj["policies"]] if obj.get("policies") is not None else None,
            "loans": [Loan.from_dict(_item) for _item in obj["loans"]] if obj.get("loans") is not None else None
        })
        return _obj


