# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class OrderManagerPlaceOfClosing(BaseModel):
    """
    OrderManagerPlaceOfClosing
    """ # noqa: E501
    id: Optional[StrictInt] = None
    name: Annotated[str, Field(min_length=1, strict=True, max_length=200)] = Field(description="The name of the place (e.g., Office Name or Venue Name).")
    phone_number: Optional[Annotated[str, Field(strict=True, max_length=20)]] = Field(default=None, description="A contact phone number for the place of closing.")
    email: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="A contact email address for the place of closing.")
    is_default: Optional[StrictBool] = Field(default=None, description="Indicates if this place should display as a default option in dropdowns for future closings.")
    notes: Optional[StrictStr] = Field(default=None, description="Additional information or notes about the place of closing.")
    created_at: Optional[datetime] = Field(default=None, description="The date and time when this place was added.")
    updated_at: Optional[datetime] = Field(default=None, description="The date and time when this place was last updated.")
    sqid: Optional[StrictStr] = None
    office: StrictInt = Field(description="The tenant office associated with this place of closing.")
    address: Optional[StrictInt] = Field(default=None, description="The address of the place of closing.")
    __properties: ClassVar[List[str]] = ["id", "name", "phone_number", "email", "is_default", "notes", "created_at", "updated_at", "sqid", "office", "address"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderManagerPlaceOfClosing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "created_at",
            "updated_at",
            "sqid",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if address (nullable) is None
        # and model_fields_set contains the field
        if self.address is None and "address" in self.model_fields_set:
            _dict['address'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderManagerPlaceOfClosing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "phone_number": obj.get("phone_number"),
            "email": obj.get("email"),
            "is_default": obj.get("is_default"),
            "notes": obj.get("notes"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "sqid": obj.get("sqid"),
            "office": obj.get("office"),
            "address": obj.get("address")
        })
        return _obj


