# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.custom_user_details import CustomUserDetails
from civitos_sdk.models.tenant import Tenant
from typing import Optional, Set
from typing_extensions import Self

class Profile(BaseModel):
    """
    Profile
    """ # noqa: E501
    sqid: Optional[StrictStr] = None
    user: CustomUserDetails
    tenant: Tenant
    job_title: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="The job title of the user.")
    is_dark_theme: Optional[StrictBool] = Field(default=None, description="Indicates if the user prefers a dark theme.")
    is_advanced_search: Optional[StrictBool] = Field(default=None, description="Indicates if the user prefers advanced search functionality.")
    is_force_logout: Optional[StrictBool] = Field(default=None, description="Indicates if the user should be logged out upon certain actions.")
    is_show_intro: Optional[StrictBool] = Field(default=None, description="Indicates if the introductory guide should be shown to the user.")
    agreed_to_terms: Optional[StrictBool] = Field(default=None, description="Indicates if the user has agreed to the terms and conditions.")
    trace: Optional[StrictBool] = Field(default=None, description="Indicates if tracing functionality is enabled for this user.")
    created_on: Optional[datetime] = Field(default=None, description="The date and time when the profile was created.")
    updated_on: Optional[datetime] = Field(default=None, description="The date and time when the profile was last updated.")
    __properties: ClassVar[List[str]] = ["sqid", "user", "tenant", "job_title", "is_dark_theme", "is_advanced_search", "is_force_logout", "is_show_intro", "agreed_to_terms", "trace", "created_on", "updated_on"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Profile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sqid",
            "created_on",
            "updated_on",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tenant
        if self.tenant:
            _dict['tenant'] = self.tenant.to_dict()
        # set to None if agreed_to_terms (nullable) is None
        # and model_fields_set contains the field
        if self.agreed_to_terms is None and "agreed_to_terms" in self.model_fields_set:
            _dict['agreed_to_terms'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Profile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sqid": obj.get("sqid"),
            "user": CustomUserDetails.from_dict(obj["user"]) if obj.get("user") is not None else None,
            "tenant": Tenant.from_dict(obj["tenant"]) if obj.get("tenant") is not None else None,
            "job_title": obj.get("job_title"),
            "is_dark_theme": obj.get("is_dark_theme"),
            "is_advanced_search": obj.get("is_advanced_search"),
            "is_force_logout": obj.get("is_force_logout"),
            "is_show_intro": obj.get("is_show_intro"),
            "agreed_to_terms": obj.get("agreed_to_terms"),
            "trace": obj.get("trace"),
            "created_on": obj.get("created_on"),
            "updated_on": obj.get("updated_on")
        })
        return _obj


