# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class State(BaseModel):
    """
    State
    """ # noqa: E501
    id: Optional[StrictInt] = None
    code: Annotated[str, Field(min_length=1, strict=True, max_length=2)]
    name: Annotated[str, Field(min_length=1, strict=True, max_length=100)]
    fips_code: Annotated[str, Field(min_length=1, strict=True, max_length=2)]
    ap_abbr: Optional[Annotated[str, Field(strict=True, max_length=10)]] = None
    capital: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    capital_tz: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    is_contiguous: Optional[StrictBool] = None
    is_continental: Optional[StrictBool] = None
    is_obsolete: Optional[StrictBool] = None
    name_metaphone: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    statehood_year: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    time_zones: Optional[Dict[str, Any]] = None
    shapefiles: Optional[Dict[str, Any]] = None
    __properties: ClassVar[List[str]] = ["id", "code", "name", "fips_code", "ap_abbr", "capital", "capital_tz", "is_contiguous", "is_continental", "is_obsolete", "name_metaphone", "statehood_year", "time_zones", "shapefiles"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of State from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if statehood_year (nullable) is None
        # and model_fields_set contains the field
        if self.statehood_year is None and "statehood_year" in self.model_fields_set:
            _dict['statehood_year'] = None

        # set to None if time_zones (nullable) is None
        # and model_fields_set contains the field
        if self.time_zones is None and "time_zones" in self.model_fields_set:
            _dict['time_zones'] = None

        # set to None if shapefiles (nullable) is None
        # and model_fields_set contains the field
        if self.shapefiles is None and "shapefiles" in self.model_fields_set:
            _dict['shapefiles'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of State from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "code": obj.get("code"),
            "name": obj.get("name"),
            "fips_code": obj.get("fips_code"),
            "ap_abbr": obj.get("ap_abbr"),
            "capital": obj.get("capital"),
            "capital_tz": obj.get("capital_tz"),
            "is_contiguous": obj.get("is_contiguous"),
            "is_continental": obj.get("is_continental"),
            "is_obsolete": obj.get("is_obsolete"),
            "name_metaphone": obj.get("name_metaphone"),
            "statehood_year": obj.get("statehood_year"),
            "time_zones": obj.get("time_zones"),
            "shapefiles": obj.get("shapefiles")
        })
        return _obj


