# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Task(BaseModel):
    """
    Task
    """ # noqa: E501
    id: Optional[StrictInt] = None
    title: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="Short title of the task.")
    description: Optional[StrictStr] = Field(default=None, description="Detailed description of the task.")
    status: Optional[StrictStr] = Field(default=None, description="Current status of the task.")
    priority: Optional[StrictStr] = Field(default=None, description="Priority of the task.")
    due_date: Optional[datetime] = Field(default=None, description="Deadline for the task.")
    created_at: Optional[datetime] = Field(default=None, description="The date and time the task was created.")
    updated_at: Optional[datetime] = Field(default=None, description="The date and time the task was last updated.")
    sqid: Optional[StrictStr] = None
    office: StrictInt
    assignee: Optional[StrictInt] = Field(default=None, description="User assigned to the task.")
    dependencies: Optional[List[StrictInt]] = Field(default=None, description="Tasks that must be completed first.")
    __properties: ClassVar[List[str]] = ["id", "title", "description", "status", "priority", "due_date", "created_at", "updated_at", "sqid", "office", "assignee", "dependencies"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['pending', 'in_progress', 'completed', 'reassigned']):
            raise ValueError("must be one of enum values ('pending', 'in_progress', 'completed', 'reassigned')")
        return value

    @field_validator('priority')
    def priority_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['low', 'medium', 'high', 'critical']):
            raise ValueError("must be one of enum values ('low', 'medium', 'high', 'critical')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Task from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "created_at",
            "updated_at",
            "sqid",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if due_date (nullable) is None
        # and model_fields_set contains the field
        if self.due_date is None and "due_date" in self.model_fields_set:
            _dict['due_date'] = None

        # set to None if assignee (nullable) is None
        # and model_fields_set contains the field
        if self.assignee is None and "assignee" in self.model_fields_set:
            _dict['assignee'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Task from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "status": obj.get("status"),
            "priority": obj.get("priority"),
            "due_date": obj.get("due_date"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "sqid": obj.get("sqid"),
            "office": obj.get("office"),
            "assignee": obj.get("assignee"),
            "dependencies": obj.get("dependencies")
        })
        return _obj


