# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from civitos_sdk.models.address import Address
from typing import Optional, Set
from typing_extensions import Self

class Tenant(BaseModel):
    """
    Tenant
    """ # noqa: E501
    id: Optional[StrictInt] = None
    address: Optional[Address]
    uuid: Optional[StrictStr] = Field(default=None, description="A universally unique identifier (UUID) for the tenant.")
    name: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="The name of the tenant.")
    phone: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The phone number for the tenant.")
    description: Optional[StrictStr] = Field(default=None, description="A description of the tenant.")
    primary_domain: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1024)]] = Field(default=None, description="The primary domain associated with the tenant.")
    contact_primary_email: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="The primary contact email address for the tenant.")
    contact_billing_email: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="The billing contact email address for the tenant.")
    ingress_email: Optional[StrictStr] = Field(default=None, description="Email address for system ingress.")
    whitelabel_bgcolor: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=7)]] = Field(default=None, description="Background color for white-labeling.")
    whitelabel_logo_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="URL for the tenant's white-label logo.")
    whitelabel_bgimage_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="URL for the white-label background image.")
    whitelabel_bgimage_color: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=7)]] = Field(default=None, description="Background image color for white-labeling.")
    whitelabel_text_primary_color: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=7)]] = Field(default=None, description="Primary text color for white-labeling.")
    whitelabel_start_page: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=255)]] = Field(default=None, description="The default start page for white-labeling.")
    homepage_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="The URL of the tenant's homepage.")
    logo_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="The URL of the tenant's logo.")
    background_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(default=None, description="The URL of the tenant's background image.")
    created_on: Optional[datetime] = Field(default=None, description="The date and time when the tenant was created.")
    updated_on: Optional[datetime] = Field(default=None, description="The date and time when the tenant was last updated.")
    sqid: Optional[StrictStr] = Field(default=None, description="A unique identifier for the tenant.")
    parent: Optional[StrictInt] = Field(default=None, description="The parent tenant for hierarchical tenant structures.")
    __properties: ClassVar[List[str]] = ["id", "address", "uuid", "name", "phone", "description", "primary_domain", "contact_primary_email", "contact_billing_email", "ingress_email", "whitelabel_bgcolor", "whitelabel_logo_url", "whitelabel_bgimage_url", "whitelabel_bgimage_color", "whitelabel_text_primary_color", "whitelabel_start_page", "homepage_url", "logo_url", "background_url", "created_on", "updated_on", "sqid", "parent"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tenant from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "uuid",
            "created_on",
            "updated_on",
            "sqid",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # set to None if address (nullable) is None
        # and model_fields_set contains the field
        if self.address is None and "address" in self.model_fields_set:
            _dict['address'] = None

        # set to None if created_on (nullable) is None
        # and model_fields_set contains the field
        if self.created_on is None and "created_on" in self.model_fields_set:
            _dict['created_on'] = None

        # set to None if updated_on (nullable) is None
        # and model_fields_set contains the field
        if self.updated_on is None and "updated_on" in self.model_fields_set:
            _dict['updated_on'] = None

        # set to None if parent (nullable) is None
        # and model_fields_set contains the field
        if self.parent is None and "parent" in self.model_fields_set:
            _dict['parent'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tenant from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "address": Address.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "uuid": obj.get("uuid"),
            "name": obj.get("name"),
            "phone": obj.get("phone"),
            "description": obj.get("description"),
            "primary_domain": obj.get("primary_domain"),
            "contact_primary_email": obj.get("contact_primary_email"),
            "contact_billing_email": obj.get("contact_billing_email"),
            "ingress_email": obj.get("ingress_email"),
            "whitelabel_bgcolor": obj.get("whitelabel_bgcolor"),
            "whitelabel_logo_url": obj.get("whitelabel_logo_url"),
            "whitelabel_bgimage_url": obj.get("whitelabel_bgimage_url"),
            "whitelabel_bgimage_color": obj.get("whitelabel_bgimage_color"),
            "whitelabel_text_primary_color": obj.get("whitelabel_text_primary_color"),
            "whitelabel_start_page": obj.get("whitelabel_start_page"),
            "homepage_url": obj.get("homepage_url"),
            "logo_url": obj.get("logo_url"),
            "background_url": obj.get("background_url"),
            "created_on": obj.get("created_on"),
            "updated_on": obj.get("updated_on"),
            "sqid": obj.get("sqid"),
            "parent": obj.get("parent")
        })
        return _obj


