# coding: utf-8

"""
    CiviTOS API

    API documentation for the CiviTOS project (dev)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Zipcode(BaseModel):
    """
    Zipcode
    """ # noqa: E501
    zipcode: Annotated[str, Field(min_length=1, strict=True, max_length=10)]
    zipcode_type: StrictStr
    major_city: Annotated[str, Field(min_length=1, strict=True, max_length=255)]
    post_office_city: Optional[Annotated[str, Field(strict=True, max_length=255)]] = None
    common_city_list: Optional[Dict[str, Any]] = None
    county: Annotated[str, Field(min_length=1, strict=True, max_length=255)]
    state: Annotated[str, Field(min_length=1, strict=True, max_length=2)]
    latitude: Optional[Union[StrictFloat, StrictInt]] = None
    longitude: Optional[Union[StrictFloat, StrictInt]] = None
    timezone: Optional[Annotated[str, Field(strict=True, max_length=50)]] = None
    bounds_west: Optional[Union[StrictFloat, StrictInt]] = None
    bounds_east: Optional[Union[StrictFloat, StrictInt]] = None
    bounds_north: Optional[Union[StrictFloat, StrictInt]] = None
    bounds_south: Optional[Union[StrictFloat, StrictInt]] = None
    population: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    population_density: Optional[Union[StrictFloat, StrictInt]] = None
    land_area_in_sqmi: Optional[Union[StrictFloat, StrictInt]] = None
    water_area_in_sqmi: Optional[Union[StrictFloat, StrictInt]] = None
    housing_units: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    occupied_housing_units: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    median_home_value: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    median_household_income: Optional[Annotated[int, Field(le=9223372036854775807, strict=True, ge=-9223372036854775808)]] = None
    polygon: Optional[Dict[str, Any]] = None
    population_by_year: Optional[Dict[str, Any]] = None
    population_by_age: Optional[Dict[str, Any]] = None
    population_by_gender: Optional[Dict[str, Any]] = None
    population_by_race: Optional[Dict[str, Any]] = None
    head_of_household_by_age: Optional[Dict[str, Any]] = None
    families_vs_singles: Optional[Dict[str, Any]] = None
    households_with_kids: Optional[Dict[str, Any]] = None
    children_by_age: Optional[Dict[str, Any]] = None
    housing_type: Optional[Dict[str, Any]] = None
    year_housing_was_built: Optional[Dict[str, Any]] = None
    housing_occupancy: Optional[Dict[str, Any]] = None
    vacancy_reason: Optional[Dict[str, Any]] = None
    owner_occupied_home_values: Optional[Dict[str, Any]] = None
    rental_properties_by_number_of_rooms: Optional[Dict[str, Any]] = None
    monthly_rent_studio: Optional[Dict[str, Any]] = None
    monthly_rent_1_bedroom: Optional[Dict[str, Any]] = None
    monthly_rent_2_bedroom: Optional[Dict[str, Any]] = None
    monthly_rent_3plus_bedroom: Optional[Dict[str, Any]] = None
    employment_status: Optional[Dict[str, Any]] = None
    average_household_income_over_time: Optional[Dict[str, Any]] = None
    household_income: Optional[Dict[str, Any]] = None
    annual_individual_earnings: Optional[Dict[str, Any]] = None
    source_of_earnings: Optional[Dict[str, Any]] = None
    means_of_transportation_to_work: Optional[Dict[str, Any]] = None
    travel_time_to_work: Optional[Dict[str, Any]] = None
    educational_attainment: Optional[Dict[str, Any]] = None
    school_enrollment: Optional[Dict[str, Any]] = None
    __properties: ClassVar[List[str]] = ["zipcode", "zipcode_type", "major_city", "post_office_city", "common_city_list", "county", "state", "latitude", "longitude", "timezone", "bounds_west", "bounds_east", "bounds_north", "bounds_south", "population", "population_density", "land_area_in_sqmi", "water_area_in_sqmi", "housing_units", "occupied_housing_units", "median_home_value", "median_household_income", "polygon", "population_by_year", "population_by_age", "population_by_gender", "population_by_race", "head_of_household_by_age", "families_vs_singles", "households_with_kids", "children_by_age", "housing_type", "year_housing_was_built", "housing_occupancy", "vacancy_reason", "owner_occupied_home_values", "rental_properties_by_number_of_rooms", "monthly_rent_studio", "monthly_rent_1_bedroom", "monthly_rent_2_bedroom", "monthly_rent_3plus_bedroom", "employment_status", "average_household_income_over_time", "household_income", "annual_individual_earnings", "source_of_earnings", "means_of_transportation_to_work", "travel_time_to_work", "educational_attainment", "school_enrollment"]

    @field_validator('zipcode_type')
    def zipcode_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['STANDARD', 'PO BOX', 'UNIQUE', 'MILITARY']):
            raise ValueError("must be one of enum values ('STANDARD', 'PO BOX', 'UNIQUE', 'MILITARY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Zipcode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if common_city_list (nullable) is None
        # and model_fields_set contains the field
        if self.common_city_list is None and "common_city_list" in self.model_fields_set:
            _dict['common_city_list'] = None

        # set to None if latitude (nullable) is None
        # and model_fields_set contains the field
        if self.latitude is None and "latitude" in self.model_fields_set:
            _dict['latitude'] = None

        # set to None if longitude (nullable) is None
        # and model_fields_set contains the field
        if self.longitude is None and "longitude" in self.model_fields_set:
            _dict['longitude'] = None

        # set to None if bounds_west (nullable) is None
        # and model_fields_set contains the field
        if self.bounds_west is None and "bounds_west" in self.model_fields_set:
            _dict['bounds_west'] = None

        # set to None if bounds_east (nullable) is None
        # and model_fields_set contains the field
        if self.bounds_east is None and "bounds_east" in self.model_fields_set:
            _dict['bounds_east'] = None

        # set to None if bounds_north (nullable) is None
        # and model_fields_set contains the field
        if self.bounds_north is None and "bounds_north" in self.model_fields_set:
            _dict['bounds_north'] = None

        # set to None if bounds_south (nullable) is None
        # and model_fields_set contains the field
        if self.bounds_south is None and "bounds_south" in self.model_fields_set:
            _dict['bounds_south'] = None

        # set to None if population (nullable) is None
        # and model_fields_set contains the field
        if self.population is None and "population" in self.model_fields_set:
            _dict['population'] = None

        # set to None if population_density (nullable) is None
        # and model_fields_set contains the field
        if self.population_density is None and "population_density" in self.model_fields_set:
            _dict['population_density'] = None

        # set to None if land_area_in_sqmi (nullable) is None
        # and model_fields_set contains the field
        if self.land_area_in_sqmi is None and "land_area_in_sqmi" in self.model_fields_set:
            _dict['land_area_in_sqmi'] = None

        # set to None if water_area_in_sqmi (nullable) is None
        # and model_fields_set contains the field
        if self.water_area_in_sqmi is None and "water_area_in_sqmi" in self.model_fields_set:
            _dict['water_area_in_sqmi'] = None

        # set to None if housing_units (nullable) is None
        # and model_fields_set contains the field
        if self.housing_units is None and "housing_units" in self.model_fields_set:
            _dict['housing_units'] = None

        # set to None if occupied_housing_units (nullable) is None
        # and model_fields_set contains the field
        if self.occupied_housing_units is None and "occupied_housing_units" in self.model_fields_set:
            _dict['occupied_housing_units'] = None

        # set to None if median_home_value (nullable) is None
        # and model_fields_set contains the field
        if self.median_home_value is None and "median_home_value" in self.model_fields_set:
            _dict['median_home_value'] = None

        # set to None if median_household_income (nullable) is None
        # and model_fields_set contains the field
        if self.median_household_income is None and "median_household_income" in self.model_fields_set:
            _dict['median_household_income'] = None

        # set to None if polygon (nullable) is None
        # and model_fields_set contains the field
        if self.polygon is None and "polygon" in self.model_fields_set:
            _dict['polygon'] = None

        # set to None if population_by_year (nullable) is None
        # and model_fields_set contains the field
        if self.population_by_year is None and "population_by_year" in self.model_fields_set:
            _dict['population_by_year'] = None

        # set to None if population_by_age (nullable) is None
        # and model_fields_set contains the field
        if self.population_by_age is None and "population_by_age" in self.model_fields_set:
            _dict['population_by_age'] = None

        # set to None if population_by_gender (nullable) is None
        # and model_fields_set contains the field
        if self.population_by_gender is None and "population_by_gender" in self.model_fields_set:
            _dict['population_by_gender'] = None

        # set to None if population_by_race (nullable) is None
        # and model_fields_set contains the field
        if self.population_by_race is None and "population_by_race" in self.model_fields_set:
            _dict['population_by_race'] = None

        # set to None if head_of_household_by_age (nullable) is None
        # and model_fields_set contains the field
        if self.head_of_household_by_age is None and "head_of_household_by_age" in self.model_fields_set:
            _dict['head_of_household_by_age'] = None

        # set to None if families_vs_singles (nullable) is None
        # and model_fields_set contains the field
        if self.families_vs_singles is None and "families_vs_singles" in self.model_fields_set:
            _dict['families_vs_singles'] = None

        # set to None if households_with_kids (nullable) is None
        # and model_fields_set contains the field
        if self.households_with_kids is None and "households_with_kids" in self.model_fields_set:
            _dict['households_with_kids'] = None

        # set to None if children_by_age (nullable) is None
        # and model_fields_set contains the field
        if self.children_by_age is None and "children_by_age" in self.model_fields_set:
            _dict['children_by_age'] = None

        # set to None if housing_type (nullable) is None
        # and model_fields_set contains the field
        if self.housing_type is None and "housing_type" in self.model_fields_set:
            _dict['housing_type'] = None

        # set to None if year_housing_was_built (nullable) is None
        # and model_fields_set contains the field
        if self.year_housing_was_built is None and "year_housing_was_built" in self.model_fields_set:
            _dict['year_housing_was_built'] = None

        # set to None if housing_occupancy (nullable) is None
        # and model_fields_set contains the field
        if self.housing_occupancy is None and "housing_occupancy" in self.model_fields_set:
            _dict['housing_occupancy'] = None

        # set to None if vacancy_reason (nullable) is None
        # and model_fields_set contains the field
        if self.vacancy_reason is None and "vacancy_reason" in self.model_fields_set:
            _dict['vacancy_reason'] = None

        # set to None if owner_occupied_home_values (nullable) is None
        # and model_fields_set contains the field
        if self.owner_occupied_home_values is None and "owner_occupied_home_values" in self.model_fields_set:
            _dict['owner_occupied_home_values'] = None

        # set to None if rental_properties_by_number_of_rooms (nullable) is None
        # and model_fields_set contains the field
        if self.rental_properties_by_number_of_rooms is None and "rental_properties_by_number_of_rooms" in self.model_fields_set:
            _dict['rental_properties_by_number_of_rooms'] = None

        # set to None if monthly_rent_studio (nullable) is None
        # and model_fields_set contains the field
        if self.monthly_rent_studio is None and "monthly_rent_studio" in self.model_fields_set:
            _dict['monthly_rent_studio'] = None

        # set to None if monthly_rent_1_bedroom (nullable) is None
        # and model_fields_set contains the field
        if self.monthly_rent_1_bedroom is None and "monthly_rent_1_bedroom" in self.model_fields_set:
            _dict['monthly_rent_1_bedroom'] = None

        # set to None if monthly_rent_2_bedroom (nullable) is None
        # and model_fields_set contains the field
        if self.monthly_rent_2_bedroom is None and "monthly_rent_2_bedroom" in self.model_fields_set:
            _dict['monthly_rent_2_bedroom'] = None

        # set to None if monthly_rent_3plus_bedroom (nullable) is None
        # and model_fields_set contains the field
        if self.monthly_rent_3plus_bedroom is None and "monthly_rent_3plus_bedroom" in self.model_fields_set:
            _dict['monthly_rent_3plus_bedroom'] = None

        # set to None if employment_status (nullable) is None
        # and model_fields_set contains the field
        if self.employment_status is None and "employment_status" in self.model_fields_set:
            _dict['employment_status'] = None

        # set to None if average_household_income_over_time (nullable) is None
        # and model_fields_set contains the field
        if self.average_household_income_over_time is None and "average_household_income_over_time" in self.model_fields_set:
            _dict['average_household_income_over_time'] = None

        # set to None if household_income (nullable) is None
        # and model_fields_set contains the field
        if self.household_income is None and "household_income" in self.model_fields_set:
            _dict['household_income'] = None

        # set to None if annual_individual_earnings (nullable) is None
        # and model_fields_set contains the field
        if self.annual_individual_earnings is None and "annual_individual_earnings" in self.model_fields_set:
            _dict['annual_individual_earnings'] = None

        # set to None if source_of_earnings (nullable) is None
        # and model_fields_set contains the field
        if self.source_of_earnings is None and "source_of_earnings" in self.model_fields_set:
            _dict['source_of_earnings'] = None

        # set to None if means_of_transportation_to_work (nullable) is None
        # and model_fields_set contains the field
        if self.means_of_transportation_to_work is None and "means_of_transportation_to_work" in self.model_fields_set:
            _dict['means_of_transportation_to_work'] = None

        # set to None if travel_time_to_work (nullable) is None
        # and model_fields_set contains the field
        if self.travel_time_to_work is None and "travel_time_to_work" in self.model_fields_set:
            _dict['travel_time_to_work'] = None

        # set to None if educational_attainment (nullable) is None
        # and model_fields_set contains the field
        if self.educational_attainment is None and "educational_attainment" in self.model_fields_set:
            _dict['educational_attainment'] = None

        # set to None if school_enrollment (nullable) is None
        # and model_fields_set contains the field
        if self.school_enrollment is None and "school_enrollment" in self.model_fields_set:
            _dict['school_enrollment'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Zipcode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "zipcode": obj.get("zipcode"),
            "zipcode_type": obj.get("zipcode_type"),
            "major_city": obj.get("major_city"),
            "post_office_city": obj.get("post_office_city"),
            "common_city_list": obj.get("common_city_list"),
            "county": obj.get("county"),
            "state": obj.get("state"),
            "latitude": obj.get("latitude"),
            "longitude": obj.get("longitude"),
            "timezone": obj.get("timezone"),
            "bounds_west": obj.get("bounds_west"),
            "bounds_east": obj.get("bounds_east"),
            "bounds_north": obj.get("bounds_north"),
            "bounds_south": obj.get("bounds_south"),
            "population": obj.get("population"),
            "population_density": obj.get("population_density"),
            "land_area_in_sqmi": obj.get("land_area_in_sqmi"),
            "water_area_in_sqmi": obj.get("water_area_in_sqmi"),
            "housing_units": obj.get("housing_units"),
            "occupied_housing_units": obj.get("occupied_housing_units"),
            "median_home_value": obj.get("median_home_value"),
            "median_household_income": obj.get("median_household_income"),
            "polygon": obj.get("polygon"),
            "population_by_year": obj.get("population_by_year"),
            "population_by_age": obj.get("population_by_age"),
            "population_by_gender": obj.get("population_by_gender"),
            "population_by_race": obj.get("population_by_race"),
            "head_of_household_by_age": obj.get("head_of_household_by_age"),
            "families_vs_singles": obj.get("families_vs_singles"),
            "households_with_kids": obj.get("households_with_kids"),
            "children_by_age": obj.get("children_by_age"),
            "housing_type": obj.get("housing_type"),
            "year_housing_was_built": obj.get("year_housing_was_built"),
            "housing_occupancy": obj.get("housing_occupancy"),
            "vacancy_reason": obj.get("vacancy_reason"),
            "owner_occupied_home_values": obj.get("owner_occupied_home_values"),
            "rental_properties_by_number_of_rooms": obj.get("rental_properties_by_number_of_rooms"),
            "monthly_rent_studio": obj.get("monthly_rent_studio"),
            "monthly_rent_1_bedroom": obj.get("monthly_rent_1_bedroom"),
            "monthly_rent_2_bedroom": obj.get("monthly_rent_2_bedroom"),
            "monthly_rent_3plus_bedroom": obj.get("monthly_rent_3plus_bedroom"),
            "employment_status": obj.get("employment_status"),
            "average_household_income_over_time": obj.get("average_household_income_over_time"),
            "household_income": obj.get("household_income"),
            "annual_individual_earnings": obj.get("annual_individual_earnings"),
            "source_of_earnings": obj.get("source_of_earnings"),
            "means_of_transportation_to_work": obj.get("means_of_transportation_to_work"),
            "travel_time_to_work": obj.get("travel_time_to_work"),
            "educational_attainment": obj.get("educational_attainment"),
            "school_enrollment": obj.get("school_enrollment")
        })
        return _obj


